﻿Option Strict On
Imports System.Xml.Linq
Imports System.Net
Imports Microsoft.Phone.Tasks

Public Class ProductInfo
    Property 画像 As String
    Property 商品名 As String
    Property 価格 As String
    Property サイト As String
End Class

Partial Public Class MainPage
    Inherits PhoneApplicationPage

    ' Constructor
    Public Sub New()
        InitializeComponent()
    End Sub

    Const AppID As String = "楽天Webサービスより取得したデベロッパーID"
    Dim xmldoc As XElement
    Dim selectGenreID As String

    Private Sub MainPage_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles MyBase.Loaded
        xmldoc = XElement.Load("RakutenGenreId.xml")
        Dim titleList As New List(Of String)

        For Each result In From c In xmldoc.Descendants("genreId") Select c
            titleList.Add(result.Attribute("title").Value)
        Next
        genreListBox.ItemsSource = titleList
    End Sub

    Private Sub Button1_Click(sender As Object, e As System.Windows.RoutedEventArgs) Handles Button1.Click
        Dim myKeyWord As String = HttpUtility.UrlEncode(TextBox1.Text)

        Dim mySort As String = HttpUtility.UrlEncode("+itemPrice")

        Dim myUri As String = String.Format("http://api.rakuten.co.jp/rws/3.0/rest?developerId={0}&operation=ItemSearch&version=2010-09-15&keyword={1}&sort={2}&genreId={3}", AppID, myKeyWord, mySort, selectGenreID)
        Dim myWebClient As New WebClient
        myWebClient.DownloadStringAsync(New Uri(myUri, UriKind.Absolute))

        AddHandler myWebClient.DownloadStringCompleted, Sub(resultSender As Object, resultArgs As DownloadStringCompletedEventArgs)
                                                            Dim xmldoc As XElement = XElement.Parse(resultArgs.Result)
                                                            Dim myProductInfo As New List(Of ProductInfo)
                                                            For Each result In From c In xmldoc.Descendants("Item") Select c
                                                                With myProductInfo
                                                                    .Add(New ProductInfo With {.画像 = result.Element("mediumImageUrl").Value,
                                                                                            .商品名 = result.Element("itemName").Value,
                                                                                            .価格 = String.Format("{0:n0}円", Integer.Parse(result.Element("itemPrice").Value)),
                                                                                            .サイト = result.Element("itemUrl").Value})
                                                                End With
                                                            Next
                                                            resultListBox.ItemsSource = myProductInfo
                                                        End Sub
    End Sub


    Private Sub genreListBox_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles genreListBox.SelectionChanged
        selectGenreID = xmldoc.Descendants("genreId")(genreListBox.SelectedIndex).Value
        Button1.IsEnabled = True
    End Sub

    Private Sub resultListBox_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles resultListBox.SelectionChanged
        Try
            Dim mySite As String = DirectCast(resultListBox.SelectedItem, ProductInfo).サイト
            Dim myBrowserTask As New WebBrowserTask
            myBrowserTask.Uri = New Uri(mySite, UriKind.Absolute)
            myBrowserTask.Show()
        Catch
            Exit Sub
        End Try
    End Sub
End Class
